<?php
/**
 *	Line In Settings API base class
 *
 *	@version 0.2.2
 */
 
if ( !class_exists( 'LIBC_Settings_API' ) ) {
	class LIBC_Settings_API {
		protected 	$_options = false;
		protected 	$_options_name;
		protected 	$reference_obj;
		protected 	$default_options;
		static 		$current_group = false;
		
		function __construct( $options, $default_options, $obj ) {
	
			$this->_options_name 	= $options['name'];
			$this->_options_id		= $options['id'];
			$this->_reference_obj	= $obj;
			$this->intro_callback	= $options['intro'];
			$this->_validation		= $options['validate'];
			$this->defaults = $default_options;
			add_action('admin_init', array( &$this, 'register_settings') );
			add_action('init', array( &$this, 'options_init'), 9 );
		}
	
		public function register_settings() {
	
			register_setting( $this->_options_name, $this->_options_name, array( $this->_reference_obj, $this->_validation ) );
			add_settings_section( $this->_options_name . '_section', false, array( $this->_reference_obj, $this->intro_callback), $this->_options_id);
			
		}
		
		
		public function get_options() {
			return $this->_options;
		}
		
		public function get_option( $option_name ) {
	
			return $this->_options[$option_name];
		}
			
		protected function _get_default_options() {
			return $this->defaults;
		}
		
		
	
		public function add_setting( $id, $title, $callback ) {
			add_settings_field( $id, $title, array( $this->_reference_obj, $callback ), $this->_options_id, $this->_options_name . '_section');
			$this->field_count++;
		}
		
		public function get_settings() {
			if ( self::$current_group != $this->_options_name ) {
				settings_fields($this->_options_name);
				self::$current_group = $this->_options_name;	
			}
			do_settings_sections($this->_options_id);
		}
		
		
		
		/**
		 *	Check to see if the options exisit in the database. If not, get the defaults
		 *	and load them in.
		 */
		function options_init() {
		     // set options equal to defaults
		     $this->_options = get_option( $this->_options_name );
		     if ( false === $this->_options ) {
				$this->_options = $this->_get_default_options();
	
		     }
		     update_option( $this->_options_name, $this->_options );
		}
	
	
	 	public function validate( $input ) {
	
	 		return $input;
	 	}
	}

}

if ( !class_exists('LI_Settings_Base') ) {
	

	abstract class LI_Settings_Base {
		protected $_intro = 'intro';
		public function get_settings() {
			$this->settings->get_settings();
		}
		public function get_options() {
			return $this->settings->get_options();
		}	
	
		
		abstract function intro();
	}
	
	
}

?>